package cn.muchinfo.rma.view.base.home.business

import android.content.Intent
import android.os.Bundle
import android.view.Gravity
import android.view.View
import android.view.ViewGroup
import androidx.appcompat.app.AppCompatActivity
import androidx.viewpager.widget.PagerAdapter
import androidx.viewpager.widget.ViewPager
import cn.muchinfo.rma.R
import cn.muchinfo.rma.global.data.BusinessData
import cn.muchinfo.rma.lifecycle.bindOptional
import cn.muchinfo.rma.view.autoWidget.*
import cn.muchinfo.rma.view.base.BaseActivity
import cn.muchinfo.rma.view.base.home.customerdata.AddCustomerDataActivity
import com.blankj.utilcode.util.ActivityUtils
import com.blankj.utilcode.util.ConvertUtils
import com.qmuiteam.qmui.util.QMUIDisplayHelper
import com.qmuiteam.qmui.widget.tab.QMUITabIndicator
import com.qmuiteam.qmui.widget.tab.QMUITabSegment
import mtp.polymer.com.autowidget.adapter.BaseAdapter
import org.jetbrains.anko.*
import org.jetbrains.anko.support.v4.viewPager

/**
 * 业务管理页面
 */
class BusinessManagementActivity : BaseActivity<BusinessManagementViewModel>(){


    lateinit var segment: QMUITabSegment
    var selectedTabIndex: Int = 0
    private lateinit var viewPager: ViewPager

    private val tabsArray: List<String> by lazy {
        arrayListOf("点价", "结算")
    }

    private val somePriceUI by lazy { SomePriceUI(this,viewModel) }
    private val settlementUI by lazy { SettlementUI(this,viewModel) }

    private val pagerAdapter: PagerAdapter by lazy {
        object : PagerAdapter() {

            override fun getPageTitle(position: Int): CharSequence? = tabsArray[position]

            override fun instantiateItem(container: ViewGroup, position: Int): Any {
                when (position) {
                    0 -> {
                        return somePriceUI.root.apply {//点价
                            container.addView(
                                this,
                                ViewGroup.LayoutParams(matchParent, matchParent)
                            )
                        }
                    }
                    1 -> {
                        return settlementUI.root.apply {//结算
                            container.addView(
                                this,
                                ViewGroup.LayoutParams(matchParent, matchParent)
                            )
                        }
                    }

                    else -> return super.instantiateItem(container, position)
                }
            }

            override fun destroyItem(container: ViewGroup, position: Int, `object`: Any) {
                (`object` as? View)?.let { container.removeView(it) }
            }

            override fun isViewFromObject(view: View, `object`: Any): Boolean = view == `object`

            override fun getCount(): Int = tabsArray.size

        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        verticalLayout {

            topBar {
                commonLeftButton()
                commonTitle {
                    text = "管理"
                }
                commonMenuButton(R.mipmap.rma_search) {
                    val intent = Intent()
                    intent.setClass(context, AddCustomerDataActivity::class.java)
                    ActivityUtils.startActivity(intent)
                }
            }

            tabSegment {
                segment = this
                background = resources.getDrawable(R.color.segtabment_bg_color)
                addOnTabSelectedListener(object :
                    QMUITabSegment.OnTabSelectedListener {
                    override fun onDoubleTap(index: Int) {}
                    override fun onTabReselected(index: Int) {}
                    override fun onTabUnselected(index: Int) {}
                    override fun onTabSelected(index: Int) {
                        selectedTabIndex = index
                    }
                })
                setIndicator(QMUITabIndicator(QMUIDisplayHelper.dp2px(context, 2), false, true))
                setDefaultTextSize(ConvertUtils.sp2px(16f), ConvertUtils.sp2px(16f))
            }.lparams(matchParent, autoSize(100))

            view {
                background = resources.getDrawable(R.color.main_hit_bg_color)
            }.lparams(matchParent, autoSize(1)) {
                marginStart = autoSize(32)
                marginEnd = autoSize(32)
            }
            viewPager {
                background = resources.getDrawable(R.color.white)
                viewPager = this
                adapter = pagerAdapter
            }.lparams(matchParent, matchParent)

            segment.setupWithViewPager(viewPager)
            segment.selectTab(selectedTabIndex)
        }
    }

    override fun onResume() {
        super.onResume()
        when (selectedTabIndex) {
            0 -> {
                viewModel.queryBusinessDJ()
            }
            1 -> {
                viewModel.queryBusinessJS()
            }
        }
    }

}

/**
 * 点价
 */

class SomePriceUI(
    private val activity: AppCompatActivity,
    private val viewModel : BusinessManagementViewModel
){
    private lateinit var swipeToLayout: SwipeToLoadLayout
    private lateinit var statusLayout: StatusLayout

    private val unSubmitAdapter: BaseAdapter<BusinessData, BusinessManagementViewholder> = BaseAdapter { _, _ -> BusinessManagementViewholder(activity, viewModel,"1") }

    val root = _FrameLayout(activity).apply {
        verticalLayout {
            viewModel.queryBusinessDJ()
            creatBusinessUI("1")

            view {
                background = resources.getDrawable(R.color.line_hint_color)
            }.lparams(matchParent, autoSize(1))

            statusLayout(contentBlock = {
                statusLayout = this
//                bindTaskStatus(viewModule.status)
                swipeToLoadLayout {
                    swipeToLayout = this
                    setEnableRefresh(true)
                    setEnableLoadMore(false)
                    setOnRefreshListener {
                        viewModel.queryBusinessDJ()
                    }
                    setEnableScrollContentWhenLoaded(false)
                    setEnableLoadMoreWhenContentNotFull(false)
                    recyclerView {
                        background = resources.getDrawable(R.color.white)
                        adapter = unSubmitAdapter
                    }.lparams(matchParent, matchParent)
                }
            }, emptyBlock = {
                emptyView(hint = resources.getString(R.string.now_no_data))
            }).lparams(matchParent, matchParent)

            viewModel.somePriceList.bindOptional(context){
                if (it?.isEmpty() == true || it?.size == 0){
                    statusLayout.showEmpty()
                }else {
                    if (swipeToLayout.getIsRefreshing()){
                        swipeToLayout.finishRefresh()
                    }
                    statusLayout.showSuccess()
                    unSubmitAdapter.setNewData(it)
                }
            }
        }
    }
}

/**
 * 结算
 * @property activity AppCompatActivity
 * @property viewModel BusinessManagementViewModel
 * @property swipeToLayout SwipeToLoadLayout
 * @property statusLayout StatusLayout
 * @property unSubmitAdapter BaseAdapter<BusinessManagementData, BusinessManagementViewholder>
 * @property root _FrameLayout
 * @constructor
 */

class SettlementUI(
    private val activity: AppCompatActivity,
    private val viewModel : BusinessManagementViewModel
){
    private lateinit var swipeToLayout: SwipeToLoadLayout
    private lateinit var statusLayout: StatusLayout

    private val unSubmitAdapter: BaseAdapter<BusinessData, BusinessManagementViewholder> = BaseAdapter { _, _ -> BusinessManagementViewholder(activity, viewModel,"2") }

    val root = _FrameLayout(activity).apply {
        verticalLayout {
            viewModel.queryBusinessJS()
            creatBusinessUI("2")

            view {
                background = resources.getDrawable(R.color.line_hint_color)
            }.lparams(matchParent, autoSize(1))

            statusLayout(contentBlock = {
                statusLayout = this
//                bindTaskStatus(viewModule.status)
                swipeToLoadLayout {
                    swipeToLayout = this
                    setEnableRefresh(true)
                    setEnableLoadMore(false)
                    setOnRefreshListener {
                        viewModel.queryBusinessJS()
                    }
                    setEnableScrollContentWhenLoaded(false)
                    setEnableLoadMoreWhenContentNotFull(false)
                    recyclerView {
                        background = resources.getDrawable(R.color.white)
                        adapter = unSubmitAdapter
                    }.lparams(matchParent, matchParent)
                }
            }, emptyBlock = {
                emptyView(hint = resources.getString(R.string.now_no_data))
            }).lparams(matchParent, matchParent)

            viewModel.settlementList.bindOptional(context){
                if (it?.isEmpty() == true || it?.size == 0){
                    statusLayout.showEmpty()
                }else {
                    if (swipeToLayout.getIsRefreshing()){
                        swipeToLayout.finishRefresh()
                    }
                    statusLayout.showSuccess()
                    unSubmitAdapter.setNewData(it)
                }
            }
        }
    }
}



fun _LinearLayout.creatBusinessUI(type : String){
    linearLayout {
        gravity = Gravity.CENTER_VERTICAL
        verticalLayout {
            textView {
                if (type == "1"){
                    text = "点价登记时间"
                }else{
                    text = "结算登记时间"
                }
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
            textView {
                if (type == "1"){
                    text = "点价审核时间"
                }else{
                    text = "结算审核时间"
                }
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
        }.lparams(wrapContent, wrapContent){
            marginStart = autoSize(37)
        }

        verticalLayout {
            textView {
                text = "合同类型"
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
            textView {
                text = "合同编号"
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
        }.lparams(wrapContent, wrapContent){
            marginStart = autoSize(155)
        }

        verticalLayout {
            textView {
                if (type== "1"){
                    text = "点价价格"
                }else{
                    text = "结算类型"
                }
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
            textView {
                if (type== "1"){
                    text = "点价金额"
                }else{
                    text = "值"
                }

                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
        }.lparams(wrapContent, wrapContent){
            marginStart = autoSize(125)
        }

        verticalLayout {
            textView {
                text = "状态"
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
            textView {
                visibility = View.GONE
                text = "计划编号"
                textColorInt = R.color.hint_text_color
                textSizeAuto = 24
            }.lparams(wrapContent, wrapContent)
        }.lparams(wrapContent, wrapContent){
            marginStart = autoSize(125)
        }
    }.lparams(matchParent, autoSize(92))
}

